//ZigZag2


#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 OrangeRed
#property indicator_color3 Green
#property indicator_color4 Red

//---- input parameters
 extern int Q = 122;   //    .   ,     .  Q = 0,  
 //      .
 extern int N = 2;     //            
 //          .
 extern int Allowance = 4;        //   Allowance  N         
 //    i          i.
 //     ,         .   
 extern bool ShowFractals = false;            //  :   ShowFractals >= true.
 extern bool UseZeroBar = false;              //     :   UseZeroBar >= true.
 extern bool Show_6_Last_Ext_ZigZag = false;  //    6  ZigZag     :
                                              //  Show_6_Last_Ext_ZigZag >= true.
 extern bool Show_6_Last_Fractals = false;    //    6         :
                                              //  Show_6_Last_Fractals >= true.
 extern int TurnEconomy = 1;                  //     = TurnEconomy,    .
 extern int SpacePoints = 3;                  //           
 
//==================================================================================================================

 double X[10000];    //     , (      ,
 //      .    )
 double Y[10000];    //     
 int E[10000];       //     
 int F[10000];       //      
 double U[10000];    //     
 double D[10000];    //     
 int H[10000];       //     
 int G[10000];       //     
 double Buffer0[];
 double Buffer1[];
 double Buffer2[];
 double Buffer3[];  
 datetime Newtime;
 double points;
 int k;
 int re;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers( 4 );
   IndicatorDigits( Digits );
	SetIndexBuffer( 0, Buffer0 ); 
	SetIndexStyle( 0, DRAW_ZIGZAG );  
	SetIndexBuffer( 1, Buffer1 ); 
	SetIndexStyle( 1, DRAW_ZIGZAG );
	
   SetIndexBuffer( 2, Buffer2 );
   SetIndexStyle( 2,DRAW_ARROW );
   SetIndexArrow( 2,217 );
   SetIndexBuffer( 3, Buffer3 ); 
   SetIndexStyle( 3,DRAW_ARROW );
   SetIndexArrow( 3,218 );
	//---- name for DataWindow and indicator subwindow label  
   IndicatorShortName( "ZigZag2" );
   SetIndexLabel( 2, "Fractal Up" );
   SetIndexLabel( 3, "Fractal Down" );       
   if ( UseZeroBar == true ) k = 1;
   if ( Q > Bars || Q == 0 ) Q = Bars; 
   points = SpacePoints * Point;
    	   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {

//---- 
     datetime time = Time[0];
     
     if ( Newtime == time && TurnEconomy < re ) return(0);
      
            if ( Newtime != time ) re = 1;
            
            re++; //     TurnEconomy < re
            
            Newtime = time; 
            
     int c = 2; 
     int limit, e, f, w, u, q1, v1;
     double s, g;
     
     int counted_bars = IndicatorCounted( );   
     //----     
     if ( counted_bars > 0 ) counted_bars--;
     limit = Q-counted_bars-1;
     //----        
      
     int i = N + 1 - k;            
     for ( i = i; i < limit; i++ )
     { 
      Buffer0[i] = EMPTY_VALUE; //  
      Buffer1[i] = EMPTY_VALUE; 
      Buffer2[i] = EMPTY_VALUE;
      Buffer3[i] = EMPTY_VALUE;      
      double high = High[i]; 
      double low = Low[i];
      int q = 0;
      int v = 0;
      int b1 = 0;
      int b2 = 0;      
      int b3 = 0;      
      int b4 = 0;
      int c1 = 0;
      int c2 = 0;
      
      //--------------------------------------              i
      
      for ( int z = 1; z < N + 1; z++ )               
      {    
           //---------  
            
           if ( high > High[i - z] ) //        ,  
           {
              q++;  //               
               if ( q == N )  //  q = N        c1  1     
               {              //  if ( b1 == 0 && b2 == 0 && c1 == 1 )         
                c1 = 1;       //         i
               }
           }
           else //   
           {
           if ( high <= High[i - z] ) //     z < N + 1   for ( int z = 1; z < N + 1; z++ )   
           {             //      i-z         i
            q = N + 1;   //     q        if ( q == N ) ,  
           }             //     if ( b1 == 0 && b2 == 0 && c1 == 1 )        
           }             //    for ( i = i; i < limit; i++ )
             
           //---------  
           
           if ( low < Low[i - z] )  //       , 
           {
              v++;  //               
                if ( v == N ) //  v = N,        c2  1    
                {             //  if ( b3 == 0 && b4 == 0 && c2 == 1 )        
                 c2 = 1;      //         i
                }      
           }
           else //  
           {
           if ( low >= Low[i - z] ) //     z < N + 1   for ( int z = 1; z < N + 1; z++ )  
           {                       //      i-z         i
            v = N + 1;             //     q        if ( v == N ), 
           }            //     if ( b3 == 0 && b4 == 0 && c2 == 1 )        
           }            //    for ( i = i; i < limit; i++ )
                
      } //     for ( int z = 1; z < N + 1; z++ ) 
      
      //--------------------------------               i
      
      q = 0; //   q  v   for ( z = 1; z < N + 1 + Allowance; z++ )   
      v = 0;
                                  
      for ( z = 1; z < N + 1 + Allowance; z++ )               
      {
         if ( b1 == 0 && b2 == 0 && c1 == 1 )  //           
         {                                     //      i   
              if ( high > High[i + z] )
              {
               q++;  //           
                 if ( q == N ) 
                 {
                       if ( ShowFractals == true || Show_6_Last_Fractals == true )
                       { 
                        q1++;          //   
                        U[q1] = high;  //    
                        H[q1] = i;     //     
                        Buffer2[i] = high + points;  // q = N ,         i  
                       }        //         for ( i = i; i < limit; i++ )  
                       b1 = 1;  //  if ( b1 == 0 && b2 == 0 && c1 == 1 )   b1  
                       
                       //=====================================================    ZigZag,   
                       
                              if ( c != 0 ) //       = 1     if ( q == N )
                              {             //  b1 = 1,      ,       
                                            //     , 
                                e = i;
                                s = high;  
                                Buffer0[e] = high; //       Buffer0[i]    X[]
                                w++; 
                                X[w] = high;       
                                E[w] = i;          //           E[]
                              }

                                   if ( c == 0 && s < high )  //           
                                   {                          //       = 0   
                                    Buffer0[e] = EMPTY_VALUE; //       Buffer0[e] 
                                    s = high;                 //         
                                    e = i;
                                    Buffer0[i] = high;  //          i
                                    X[w] = high;        //          X[]   
                                    E[w] = i;           //            E[]
                                   }
                                   c = 0;               //        if ( c != 0 )
                                                         
                 //================================================================      ZigZag. 
                
                 } //     if ( q == N )
              } //     if ( high > High[i + z] )
              else //   
              {
              if ( high < High[i + z] )  //             
              {         //   ,         
               b2 = 1;  //   for( i = i; i < limit; i++ )   if ( b1 == 0 && b2 == 0 && c1 == 1 )
              }         //   b2 
              }
                   if ( high == High[i + z] ) //           i 
                   {                          // , 
                    q = 0;                //   0  q++       if ( q == N )
                   }                      //           z < N + 1 + Allowance
                                          //   for ( z = 1; z < N + 1 + Allowance; z++ )
                                              
         }  //     if ( b1 == 0 && b2 == 0 && c1 == 1 )
         
         //---------------------------------------------------------------------   .
         
         if ( b3 == 0 && b4 == 0 && c2 == 1 )  //           
         {                                     //      i   
              if ( low < Low[i + z] )
              {
               v++;     //            
                  if ( v == N )
                  {
                        if ( ShowFractals == true || Show_6_Last_Fractals == true )
                        {
                         v1++;          //   
                         D[v1] = low;   //    
                         G[v1] = i;     //      
                         Buffer3[i] = low - points;  //  v = N ,         i   
                        }       //         for ( i = i; i < limit; i++ )
                    b3 = 1;     //  ( b3 == 0 && b4 == 0 && c2 == 1 )   b3  
                    
                   //=======================================================================    ZigZag 
                   
                             if ( c != 1 )//       = 0     if ( v == N )
                             {            //  b3 = 1,      ,     
                                          //     ,
                              f = i;
                              g = low;
                              Buffer1[i] = low; //       Buffer1[i]    Y[]
                              u++;
                              Y[u] = low;
                              F[u] = i;         //           F[]
                             }
           
                                  if ( c == 1 && g > low )   //          
                                  {                          //      c = 0,   
                                   Buffer1[f] = EMPTY_VALUE; //       Buffer1[f]
                                   g = low;                  //    f    
                                   f = i;
                                   Buffer1[i] = low;   //          i
                                   Y[u] = low;         //          Y[]   
                                   F[u] = i;           //            F[]   
                                  } 
                                  c = 1;               //        if ( c != 1 )     
                                        
                  //=====================================================================     ZigZag
                   
                  } //     if ( v == N )
              }  //     if ( low < Low[i + z] )
              else  //   
              {
              if ( low > Low[i + z] ) //          
              {                       //   ,        
               b4 = 1;  //   for( i = i; i < limit; i++ )   if ( b3 == 0 && b4 == 0 && c2 == 1 )
              }         //   b4 
              }    
             
                   if ( low == Low[i + z] ) //           i
                   {                        // , 
                    v = 0;               //   0  v++       if ( v == N )
                   }                     //           z < N + 1 + Allowance
                                         //   for ( z = 1; z < N + 1 + Allowance; z++ )
                                            
           }  //     if ( b3 == 0 && b4 == 0 && c2 == 1 )
           
                   if ( b1 == 1 && b2 == 1 && b3 == 1 && b4 == 1 )
                   {
                    break;    //   for ( z = 1; z < N + 1 + Allowance; z++ )
                   }
                    
       }  //     for ( z = 1; z < N + 1 + Allowance; z++ )
       
    } //     for ( i = i; i < limit; i++ )                 
     
   //---------------------------------------------------------------------------------------------- 
        
         string text = " ";
         if ( Show_6_Last_Ext_ZigZag == true )
         {
          text = StringConcatenate( " ZigZag Maxs:   ",X[1]," [ "+E[1]+" ]    ", X[2]," [ "+E[2]+" ]    ",
          X[3]," [ "+E[3]+" ]    ",X[4]," [ "+E[4]+" ]    ",X[5]," [ "+E[5]+" ]    ",X[6], " [ "+E[6]+" ]",
          "\n\n ZigZag Mins:   ",Y[1]," [ "+F[1]+" ]    ", Y[2]," [ "+F[2]+" ]    ",
          Y[3]," [ "+F[3]+" ]    ",Y[4]," [ "+F[4]+" ]    ",Y[5]," [ "+F[5]+" ]    ",Y[6], " [ "+F[6]+" ] " );
         }
         else
         {
         if ( Show_6_Last_Fractals == true )
         {
          text = StringConcatenate( " Fractals Up:   ",U[1]," [ "+H[1]+" ]    ", U[2]," [ "+H[2]+" ]    ",
          U[3]," [ "+H[3]+" ]    ",U[4]," [ "+H[4]+" ]    ",U[5]," [ "+H[5]+" ]    ",U[6], " [ "+H[6]+" ]",
          "\n\n Fractals Down:   ",D[1]," [ "+G[1]+" ]    ", D[2]," [ "+G[2]+" ]    ",
          D[3]," [ "+G[3]+" ]    ",D[4]," [ "+G[4]+" ]    ",D[5]," [ "+G[5]+" ]    ",D[6], " [ "+G[6]+" ] " );
         }
         } 
              
         Comment( text );
         
   return(0);
  }
//+------------------------------------------------------------------+